﻿// Disclaimer:
// This software is provided AS IS for educational purposes only,
// with no warranties, and confers no rights. Error checking is 
// elided for clarity. Carry out sufficient tests prior to using
// it in a productive environment.
// CASIO Europe GmbH accepts no responsibility for loss or damage
// arising from its use, including damage from virus.
//
// Please, note: This configuration information may be changed
// without any further notice.
// Casio Europe GmbH does not guarantee future compatibility. By 
// using this software you agree to these terms and conditions.
//
// Version 1.00 - January 11, 2012
// Supported Devices: IT-300, IT-800
//
// Remarks: You need latest versions of CASIO runtime libraries on
// your mobile device. If they are not already installed, you can 
// find them as part of the SDK.
//////////////////////////////////////////////////////////////////////

using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using Microsoft.WindowsCE.Forms;

namespace VirtualOff
{
    internal sealed class PowerBroadcast : MessageWindow
    {
        #region Fields

        private MainForm owner;

        private const int WM_POWERBROADCAST = 0x218;
        private const int PBT_APMSUSPEND = 0x0004;
        private const int PBT_APMRESUMECRITICAL = 0x0006;
        private const int PBT_APMRESUMESUSPEND = 0x0007;
        private const int PBT_APMBATTERYLOW = 0x0009;

        #endregion

        #region Init

        internal PowerBroadcast(MainForm owner)
        {
            this.owner = owner;
        }

        #endregion

        #region Overrides

        protected override void WndProc(ref Message m)
        {
            if (m.Msg == WM_POWERBROADCAST)
            {
                switch (m.WParam.ToInt32())
                {
                    case PBT_APMRESUMESUSPEND:
                        this.owner.OnResumeSuspend();
                        break;
                    case PBT_APMBATTERYLOW:
                        this.owner.OnBatteryLow();
                        break;
                    case PBT_APMSUSPEND:
                        this.owner.OnSuspend();
                        break;
                    default:
                        break;
                }
            }

            base.WndProc(ref m);
        }

        #endregion
    }
}
